%------ Lez1 12 marzo 2012 ------ 

clear all;
close all
clc
% Esercizio di riscaldamento;
% Fate un figura con 2 subplot, un imagesc con range definito di una
% matrice random, e il plot di una funzione;

% Ricordatevi i comandi:
% figure
% set
% subplot
% imagesc
% randn

A = randn(10,10);
Y = sin([0:0.1:10]);

h0=figure;
set(h0,'name','Esercizio');
subplot(211);
imagesc(A,[-5,5]); colorbar;
subplot(212);
plot(Y);






%% Visualizzazione dati 2D 
A2d = normrnd(1,4,[100,2]);
h1=figure;
set(h1,'name','Scatter');
scatter(A2d(:,1),A2d(:,2)); 

%% Visualizzazione testo

text(A2d(1,1)-0.15,A2d(1,2)+0.5,'1');

% Individuare le posizioni dei pallini da figura da interfaccia (DA SOLI);
% Modificare le proprieta' grafiche con le proprieta' delle figure;

%% Visualizzazione 3D
A3d = normrnd(1,4,[100,3]);
h2=figure;
set(h2,'name','Scatter3');
scatter3(A3d(:,1),A3d(:,2),A3d(:,3)); 

%% Visualizzazione testo
text(A3d(1,1)-0.15,A3d(1,2)+0.5,A3d(1,3),'1');

% Routare la figura, fare lo zoom
% hold on, ed un'altra scatterata


%% Visualizzazione istogramma

A = imread('cameraman.tif');
h3 = figure;
set(h3,'name','Immagine');
imagesc(A);
colorbar
colormap gray

axis image
axis equal
axis ij
axis xy

dbclear all

saveas(h3,'IlFotografo.jpg')

Ah = hist(double(A(:)),128);
h4 = figure;
set(h4,'name','Istogramma immagine');
bar(linspace(0,255,128),Ah)

%% SURF
h5 = figure;
set(h5,'name','surf');
surf(double(A));
shading interp

%%ESERCIZIO: visualizzare in surf esclusivamente la faccia 
% del fotografo;

%Soluzione1 (traccia); ritagliare una sottomatrice dell'immagine originale
% che contenga la faccia, e visualizzare con surf;

%Soluzione 2: utilizzo di imcrop;
Acrop = imcrop(A);
h5bis = figure; set(h5bis,'name','crop');
surf(double(Acrop)); shading interp


%% cicli for
for i=1:100
    fprintf('Mi chiamo CicloFor %i\n',i);
end

for i=1:10:100
    fprintf('Mi chiamo CicloFor %i\n',i);
end

%attenzione! qui sopra non ho istanziato un conteggio...
% ma l'ispezione di un vettore.. infatti:
for i=[1,4,3,5,6,4,2,3,4,53,2];
     fprintf('Mi chiamo CicloFor %i\n',i);
end 
    
%Provare a fare modifiche ripetute sull'immagine
% con un ciclo for e visualizzare con il montaggio

num_el = length(A(:));
% A(:) linearizza una matrice in un vettore
% colonna;

% ind2sub, sub2ind per cambiare indicizzazione di una matrice;
% singolo = sub2ind(size(A),1,2)

num_op = floor(num_el/5); 

for i=5:5:num_el
    A(i)=0;
end

h5tris=figure;
set(h5tris,'name','noisy image');
imagesc(A);
colormap gray
    
% visualizzazione su volume;
A = imread('cameraman.tif');
num_el = length(A(:));
num_op = floor(num_el/625);
Amovie = zeros(256,256,num_op);
cont = 0;
h6 = figure;
set(h6,'name','Operazioni in ciclo for')
for i=625:625:num_el
    A(i)=0;
    cont = cont +1;
    Amovie(:,:,cont) = A;
    figure(h6);
    imagesc(Amovie(:,:,cont));
    colormap gray;
    pause(1)
end

